## pappl 1.0.1

=== man/Makefile ===
#
# Man page makefile for the Printer Application Framework
#
# Copyright © 2020 by Michael R Sweet
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


MAN1	=	\
		pappl.1 \
		pappl-makeresheader.1

MAN3	=	\
		pappl-client.3 \
		pappl-device.3 \
		pappl-job.3 \
		pappl-log.3 \
		pappl-mainloop.3 \
		pappl-printer.3 \
		pappl-resource.3 \
		pappl-system.3


# Make everything
all:


# Clean everything
clean:


# Clean all non-distribution files
distclean:	clean


# Update dependencies
depend:


# Install everything
install:
	echo Installing man pages in $(BUILDROOT)/$(mandir)/man1...
	$(INSTALL) -d -m 755 $(BUILDROOT)/$(mandir)/man1
	for file in $(MAN1); do \
		$(INSTALL) -c -m 644 $$file $(BUILDROOT)/$(mandir)/man1; \
	done
	echo Installing man pages in $(BUILDROOT)/$(mandir)/man3...
	$(INSTALL) -d -m 755 $(BUILDROOT)/$(mandir)/man3
	for file in $(MAN3); do \
		$(INSTALL) -c -m 644 $$file $(BUILDROOT)/$(mandir)/man3; \
	done


# Test everything
test:

=== pappl/Makefile ===
#
# Library makefile for the Printer Application Framework
#
# Copyright © 2020 by Michael R Sweet
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


OBJS	=	\
		client.o \
		client-accessors.o \
		client-auth.o \
		client-ipp.o \
		client-webif.o \
		contact.o \
		device.o \
		device-file.o \
		device-network.o \
		device-usb.o \
		dnssd.o \
		job-accessors.o \
		job-filter.o \
		job-ipp.o \
		job-process.o \
		job.o \
		link.o \
		log.o \
		lookup.o \
		mainloop.o \
		mainloop-subcommands.o \
		mainloop-support.o \
		printer.o \
		printer-accessors.o \
		printer-driver.o \
		printer-ipp.o \
		printer-raw.o \
		printer-support.o \
		printer-usb.o \
		printer-webif.o \
		resource.o \
		snmp.o \
		system.o \
		system-accessors.o \
		system-ipp.o \
		system-loadsave.o \
		system-printer.o \
		system-webif.o \
		util.o

HEADERS	=	\
		base.h \
		client.h \
		device.h \
		job.h \
		log.h \
		mainloop.h \
		pappl.h \
		printer.h \
		system.h

RESOURCES =	\
		icon-sm.png \
		icon-md.png \
		icon-lg.png \
		style.css

DOCFLAGS =	\
		--author "Michael R Sweet" \
		--copyright "Copyright (c) 2020 by Michael R Sweet" \
		--docversion $(PAPPL_VERSION)

.SUFFIXES:	md
DOCFILES =	\
		device.md \
		hello-world.md \
		introduction.md \
		job.md \
		mainloop.md \
		printer.md \
		resource.md \
		system.md

TARGETS	=	$(LIBPAPPL) libpappl.a


# Make everything
all:		$(TARGETS)


# Clean everything
clean:
	$(RM) $(OBJS)
	$(RM) $(TARGETS)
	$(RM) libpappl.dylib libpappl.so


# Clean all non-distribution files
distclean:	clean


# Update dependencies
depend:
	$(CC) -MM $(CFLAGS) $(OBJS:.o=.c) | sed -e '1,$$s/ \/usr\/include\/[^ ]*//g' -e '1,$$s/ \/usr\/local\/include\/[^ ]*//g' >Dependencies


# Generate documentation uaing codedoc (https://www.msweet.org/codedoc)
doc:
	echo Generating pappl.html...
	codedoc $(DOCFLAGS) --title "PAPPL v$(PAPPL_VERSION_MAJOR).$(PAPPL_VERSION_MINOR) Programmers Manual" --coverimage ../doc/pappl-512.png --body ../doc/pappl-body.md pappl.xml $(HEADERS) $(OBJS:.o=.c) >../doc/pappl.html
	echo Generating pappl.epub...
	codedoc $(DOCFLAGS) --title "PAPPL v$(PAPPL_VERSION_MAJOR).$(PAPPL_VERSION_MINOR) Programmers Manual" --coverimage epub.png --body ../doc/pappl-body.md pappl.xml --epub ../doc/pappl.epub
	$(RM) pappl.xml
	echo Generating pappl-client.3...
	codedoc $(DOCFLAGS) --title "pappl client functions" --man pappl-client --section 3 --body ../man/pappl-client-body.man --footer ../man/pappl-footer.man client.h client*.c >../man/pappl-client.3
	echo Generating pappl-device.3...
	codedoc $(DOCFLAGS) --title "pappl device functions" --man pappl-device --section 3 --body ../man/pappl-device-body.man --footer ../man/pappl-footer.man device.h device.c >../man/pappl-device.3
	echo Generating pappl-job.3...
	codedoc $(DOCFLAGS) --title "pappl job functions" --man pappl-job --section 3 --body ../man/pappl-job-body.man --footer ../man/pappl-footer.man job.h job*.c >../man/pappl-job.3
	echo Generating pappl-log.3...
	codedoc $(DOCFLAGS) --title "pappl logging functions" --man pappl-log --section 3 --body ../man/pappl-log-body.man --footer ../man/pappl-footer.man log.h log.c >../man/pappl-log.3
	echo Generating pappl-mainloop.3...
	codedoc $(DOCFLAGS) --title "pappl main loop functions" --man pappl-mainloop --section 3 --body ../man/pappl-mainloop-body.man --footer ../man/pappl-footer.man mainloop.h mainloop*.c >../man/pappl-mainloop.3
	echo Generating pappl-printer.3...
	codedoc $(DOCFLAGS) --title "pappl printer functions" --man pappl-printer --section 3 --body ../man/pappl-printer-body.man --footer ../man/pappl-footer.man printer.h printer*.c >../man/pappl-printer.3
	echo Generating pappl-resource.3...
	codedoc $(DOCFLAGS) --title "pappl resource functions" --man pappl-resource --section 3 --body ../man/pappl-resource-body.man --footer ../man/pappl-footer.man link.c resource.c >../man/pappl-resource.3
	echo Generating pappl-system.3...
	codedoc $(DOCFLAGS) --title "pappl system functions" --man pappl-system --section 3 --body ../man/pappl-system-body.man --footer ../man/pappl-footer.man system.h system*.c >../man/pappl-system.3


# Install everything
install:	$(TARGETS)
	echo Installing pappl-makeresheader in $(BUILDROOT)$(bindir)...
	$(INSTALL) -d -m 755 $(BUILDROOT)$(bindir)
	$(INSTALL) -c -m 755 makeresheader.sh $(BUILDROOT)$(bindir)/pappl-makeresheader
	echo Installing libpappl in $(BUILDROOT)$(libdir)...
	$(INSTALL) -d -m 755 $(BUILDROOT)$(libdir)
	$(INSTALL) -c -m 644 libpappl.a $(BUILDROOT)$(libdir)
	$(INSTALL) -c -m 755 $(LIBPAPPL) $(BUILDROOT)$(libdir)
	if test "$(LIBPAPPL)" = libpappl.so.1; then \
		$(RM) $(BUILDROOT)$(libdir)/libpappl.so; \
		$(LN) -s libpappl.so.1 $(BUILDROOT)$(libdir)/libpappl.so; \
	elif test "$(LIBPAPPL)" = libpappl.1.dylib; then \
		$(RM) $(BUILDROOT)$(libdir)/libpappl.dylib; \
		$(LN) -s libpappl.1.dylib $(BUILDROOT)$(libdir)/libpappl.dylib; \
	fi
	echo Installing pkg-config files in $(BUILDROOT)$(libdir)/pkgconfig...
	$(INSTALL) -d -m 755 $(BUILDROOT)$(libdir)/pkgconfig
	$(INSTALL) -c -m 644 pappl.pc $(BUILDROOT)$(libdir)/pkgconfig
	echo Installing data files in $(BUILDROOT)$(datadir)/pappl...
	$(INSTALL) -d -m 755 $(BUILDROOT)$(datadir)/pappl
	for file in $(RESOURCES); do \
		$(INSTALL) -c -m 644 $$file $(BUILDROOT)$(datadir)/pappl; \
	done
	echo Installing header files in $(BUILDROOT)$(includedir)/pappl...
	$(INSTALL) -d -m 755 $(BUILDROOT)$(includedir)/pappl
	for file in $(HEADERS); do \
		$(INSTALL) -c -m 644 $$file $(BUILDROOT)$(includedir)/pappl; \
	done


# Test everything
test:


# pappl static library
libpappl.a:		$(OBJS)
	echo Archiving $@...
	$(RM) $@
	$(AR) $(ARFLAGS) $@ $(OBJS)
	$(RANLIB) $@


# pappl shared library
libpappl.so.1:		$(OBJS)
	echo Linking $@...
	$(CC) $(DSOFLAGS) -shared -o $@ -Wl,-soname,$@ $(OBJS) $(LIBS)
	$(RM) `basename $@ .1`
	$(LN) $@ `basename $@ .1`


# pappl shared library (macOS)
libpappl.1.dylib:	$(OBJS)
	echo Linking $@...
	$(CC) $(DSOFLAGS) -dynamiclib -o $@ \
		-install_name $(libdir)/$@ \
		-current_version $(PAPPL_VERSION_MAJOR).$(PAPPL_VERSION_MINOR) -compatibility_version 1.0 \
		$(OBJS) $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) -i org.msweet.pappl.`basename $@ .1.dylib` $@
	$(RM) `basename $@ .1.dylib`.dylib
	$(LN) $@ `basename $@ .1.dylib`.dylib


# Static resource header...
resheader:	$(RESOURCES)
	echo Generating $@...
	./makeresheader.sh $(RESOURCES) >resource-private.h


# Dependencies
include Dependencies

=== testsuite/Makefile ===
#
# Test suite makefile for the Printer Application Framework
#
# Copyright © 2020 by Michael R Sweet
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


OBJS	=	\
		pwg-driver.o \
		testmainloop.o \
		testpappl.o

TARGETS	=	\
		testmainloop \
		testpappl


# Make everything
all:		$(TARGETS)


# Clean everything
clean:
	$(RM) -r $(OBJS) $(TARGETS)


# Clean all non-distribution files
distclean:	clean


# Update dependencies
depend:
	$(CC) -MM $(CFLAGS) $(OBJS:.o=.c) | sed -e '1,$$s/ \/usr\/include\/[^ ]*//g'  -e '1,$$s/ \/usr\/local\/include\/[^ ]*//g' >Dependencies


# Install everything
install:


# Test everything
test:		testpappl
	$(RM) testpappl.log
	$(RM) -r testpappl.output
	$(MKDIR) testpappl.output
	./testpappl -c -l testpappl.log -L debug -o testpappl.output -t all


# Test suite program
testpappl:	testpappl.o pwg-driver.o ../pappl/libpappl.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testpappl.o pwg-driver.o ../pappl/libpappl.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) -i org.msweet.pappl.$@ $@


# Mainloop test program
testmainloop:	testmainloop.o pwg-driver.o ../pappl/libpappl.a
	echo Linking $@...
	$(CC) $(LDFLAGS) -o $@ testmainloop.o pwg-driver.o ../pappl/libpappl.a $(LIBS)
	$(CODE_SIGN) $(CSFLAGS) -i org.msweet.pappl.$@ $@


# Static resource header...
resheader:
	echo Generating $@...
	../pappl/makeresheader.sh label-*.png >label-png.h


# Dependencies
include Dependencies

=== debian/changelog ===
pappl (1.0.1-2) unstable; urgency=medium

  * Set upstream metadata fields: Security-Contact

 -- Didier Raboud <odyx@debian.org>  Wed, 03 Feb 2021 22:47:35 +0100

pappl (1.0.1-1) unstable; urgency=medium

  * Initial release. (Closes: #980200)

 -- Didier Raboud <odyx@debian.org>  Wed, 20 Jan 2021 10:20:40 +0100

=== debian/control ===
Source: pappl
Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Uploaders: Didier Raboud <odyx@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libavahi-client-dev,
               libcups2-dev,
               libcupsimage2-dev,
               libgnutls28-dev,
               libjpeg-dev,
               libpam0g-dev,
               libpng-dev,
               libusb-1.0-0-dev,
               zlib1g-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/printing-team/pappl
Vcs-Git: https://salsa.debian.org/printing-team/pappl.git
Homepage: https://www.msweet.org/pappl/
Rules-Requires-Root: no

Package: libpappl1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C-based framework/library for developing CUPS Printer Applications
 PAPPL is a simple C-based framework/library for developing CUPS Printer
 Applications, which are the recommended replacement for printer drivers. It
 was specifically developed to support LPrint and a future Gutenprint Printer
 Application but is sufficiently general purpose to support any kind of printer
 or driver that can be used on desktops, servers, and in embedded environments.

Package: libpappl-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpappl1 (= ${binary:Version}),
         ${misc:Depends},
         libcups2-dev,
         libgnutls28-dev,
         libjpeg-dev,
         libpam0g-dev,
         libpng-dev,
         libusb-1.0-0-dev,
         zlib1g-dev
Description: C-based framework/library for developing CUPS Printer Applications - Headers
 PAPPL is a simple C-based framework/library for developing CUPS Printer
 Applications, which are the recommended replacement for printer drivers. It
 was specifically developed to support LPrint and a future Gutenprint Printer
 Application but is sufficiently general purpose to support any kind of printer
 or driver that can be used on desktops, servers, and in embedded environments.
 .
 This package contains the static library, headers and documentation.

=== debian/tests/control ===
Tests: testsuite
Depends: libpappl-dev, build-essential, pkg-config, avahi-daemon

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/pappl-$1\.tar\.gz/ \
  https://github.com/michaelrsweet/pappl/tags .*/v?(\d\S+)\.tar\.gz

## pappl 1.0.3

=== Makefile ===
#
# Top-level makefile for the Printer Application Framework
#
# Copyright © 2020 by Michael R Sweet
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include Makedefs


# Source directories...
DIRS	=	\
		doc \
		man \
		pappl \
		testsuite


# Make all targets...
all:
	echo Using CC="$(CC)"
	echo Using CFLAGS="$(CFLAGS)"
	echo Using DSOFLAGS="$(DSOFLAGS)"
	echo Using LDFLAGS="$(LDFLAGS)"
	echo Using LIBS="$(LIBS)"
	for dir in $(DIRS); do \
		echo Making all in $$dir...; \
		(cd $$dir; $(MAKE) $(MFLAGS) all) || exit 1; \
	done


# Remove object and target files...
clean:
	$(RM) testpappl.state
	for dir in $(DIRS); do \
		echo Cleaning all in $$dir...; \
		(cd $$dir; $(MAKE) $(MFLAGS) clean) || exit 1; \
	done


# Remove all non-distribution files...
distclean:	clean
	$(RM) Makedefs config.h config.log config.status pappl/pappl.pc
	-$(RM) -r autom4te*.cache


# Make dependencies
depend:
	for dir in $(DIRS); do \
		echo Updating dependencies in $$dir...; \
		(cd $$dir; $(MAKE) $(MFLAGS) depend) || exit 1; \
	done


# Install everything...
install:
	for dir in $(DIRS); do \
		echo Installing in $$dir...; \
		(cd $$dir; $(MAKE) $(MFLAGS) install) || exit 1; \
	done


# Test everything...
test:
	for dir in $(DIRS); do \
		echo Testing in $$dir...; \
		(cd $$dir; $(MAKE) $(MFLAGS) test) || exit 1; \
	done


# Don't run top-level build targets in parallel...
.NOTPARALLEL:

=== debian/changelog ===
pappl (1.0.3-2) unstable; urgency=medium

  * Migrate to unstable
  * Remove myself from Uploaders
  * S-V: Update to 4.6.0 without changes needed
  * Update Salsa CI configuration

 -- Didier Raboud <odyx@debian.org>  Fri, 03 Sep 2021 17:04:22 +0200

pappl (1.0.3-1) experimental; urgency=medium

  * New 1.0.3 upstream release
    - Drop backported patches

 -- Didier Raboud <odyx@debian.org>  Fri, 23 Apr 2021 10:55:26 +0200

pappl (1.0.2-2) experimental; urgency=medium

  * Backport upstream patch to fix arm FTBFS;
    - Fix some more threading issues (Issue #155, Issue #162)

 -- Didier Raboud <odyx@debian.org>  Wed, 14 Apr 2021 08:09:47 +0200

pappl (1.0.2-1) experimental; urgency=medium

  * New 1.0.2 upstream release
    - Backport upstream fix for test suite
    - Handle when the Avahi daemon is not running (Issue #129)

 -- Didier Raboud <odyx@debian.org>  Sun, 11 Apr 2021 19:09:06 +0200

=== debian/control ===
Source: pappl
Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Section: net
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 libavahi-client-dev,
 libcups2-dev,
 libcupsimage2-dev,
 libgnutls28-dev,
 libjpeg-dev,
 libpam0g-dev,
 libpng-dev,
 libusb-1.0-0-dev,
 zlib1g-dev,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/printing-team/pappl
Vcs-Git: https://salsa.debian.org/printing-team/pappl.git
Homepage: https://www.msweet.org/pappl/
Rules-Requires-Root: no

Package: libpappl1
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C-based framework/library for developing CUPS Printer Applications
 PAPPL is a simple C-based framework/library for developing CUPS Printer
 Applications, which are the recommended replacement for printer drivers. It
 was specifically developed to support LPrint and a future Gutenprint Printer
 Application but is sufficiently general purpose to support any kind of printer
 or driver that can be used on desktops, servers, and in embedded environments.

Package: libpappl-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libcups2-dev,
 libgnutls28-dev,
 libjpeg-dev,
 libpam0g-dev,
 libpappl1 (= ${binary:Version}),
 libpng-dev,
 libusb-1.0-0-dev,
 zlib1g-dev,
 ${misc:Depends},
Description: C-based framework/library for developing CUPS Printer Applications - Headers
 PAPPL is a simple C-based framework/library for developing CUPS Printer
 Applications, which are the recommended replacement for printer drivers. It
 was specifically developed to support LPrint and a future Gutenprint Printer
 Application but is sufficiently general purpose to support any kind of printer
 or driver that can be used on desktops, servers, and in embedded environments.
 .
 This package contains the static library, headers and documentation.

=== debian/tests/control ===
Tests: testsuite
Depends:
 avahi-daemon,
 build-essential,
 libpappl-dev,
 pkg-config,

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ \
  https://github.com/michaelrsweet/pappl/releases .*/pappl-(\d\S+)\.tar\.gz

## pappl 1.2.1

=== pappl/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # Library makefile for the Printer Application Framework
 #
-# Copyright © 2020 by Michael R Sweet
+# Copyright © 2020-2022 by Michael R Sweet
 #
 # Licensed under Apache License v2.0.  See the file "LICENSE" for more
 # information.
@@ -10,10 +10,11 @@
 include ../Makedefs
 
 
-OBJS	=	\
+BASEOBJS =	\
 		client.o \
 		client-accessors.o \
 		client-auth.o \
+		client-loc.o \
 		client-ipp.o \
 		client-webif.o \
 		contact.o \
@@ -22,12 +23,14 @@
 		device-network.o \
 		device-usb.o \
 		dnssd.o \
+		httpmon.o \
 		job-accessors.o \
 		job-filter.o \
 		job-ipp.o \
 		job-process.o \
 		job.o \
 		link.o \
+		loc.o \
 		log.o \
 		lookup.o \
 		mainloop.o \
@@ -43,23 +46,33 @@
 		printer-webif.o \
 		resource.o \
 		snmp.o \
+		subscription.o \
+		subscription-ipp.o \
 		system.o \
 		system-accessors.o \
 		system-ipp.o \
 		system-loadsave.o \
+		system-loc.o \
 		system-printer.o \
+		system-subscription.o \
 		system-webif.o \
 		util.o
+
+OBJS	=	\
+		$(BASEOBJS) \
+		$(SYSTEM_STATUS)
 
 HEADERS	=	\
 		base.h \
 		client.h \
 		device.h \
 		job.h \
+		loc.h \
 		log.h \
 		mainloop.h \
 		pappl.h \
 		printer.h \
+		subscription.h \
 		system.h
 
 RESOURCES =	\
@@ -68,9 +81,17 @@
 		icon-lg.png \
 		style.css
 
+STRINGS =	\
+		strings/de.strings \
+		strings/en.strings \
+		strings/es.strings \
+		strings/fr.strings \
+		strings/it.strings \
+		strings/ja.strings
+
 DOCFLAGS =	\
 		--author "Michael R Sweet" \
-		--copyright "Copyright (c) 2020 by Michael R Sweet" \
+		--copyright "Copyright (c) 2020-2022 by Michael R Sweet" \
 		--docversion $(PAPPL_VERSION)
 
 .SUFFIXES:	md
@@ -104,13 +125,13 @@
 
 # Update dependencies
 depend:
-	$(CC) -MM $(CFLAGS) $(OBJS:.o=.c) | sed -e '1,$$s/ \/usr\/include\/[^ ]*//g' -e '1,$$s/ \/usr\/local\/include\/[^ ]*//g' >Dependencies
+	$(CC) -MM $(CFLAGS) `echo $(OBJS:.o=.c) | sed -e '1,$$s/-macos\.c/-macos.m/g'` | sed -e '1,$$s/ \/usr\/include\/[^ ]*//g' -e '1,$$s/ \/usr\/local\/include\/[^ ]*//g' >Dependencies
 
 
 # Generate documentation uaing codedoc (https://www.msweet.org/codedoc)
 doc:
 	echo Generating pappl.html...
-	codedoc $(DOCFLAGS) --title "PAPPL v$(PAPPL_VERSION_MAJOR).$(PAPPL_VERSION_MINOR) Programmers Manual" --coverimage ../doc/pappl-512.png --body ../doc/pappl-body.md pappl.xml $(HEADERS) $(OBJS:.o=.c) >../doc/pappl.html
+	codedoc $(DOCFLAGS) --title "PAPPL v$(PAPPL_VERSION_MAJOR).$(PAPPL_VERSION_MINOR) Programmers Manual" --coverimage ../doc/pappl-512.png --body ../doc/pappl-body.md pappl.xml $(HEADERS) $(BASEOBJS:.o=.c) >../doc/pappl.html
 	echo Generating pappl.epub...
 	codedoc $(DOCFLAGS) --title "PAPPL v$(PAPPL_VERSION_MAJOR).$(PAPPL_VERSION_MINOR) Programmers Manual" --coverimage epub.png --body ../doc/pappl-body.md pappl.xml --epub ../doc/pappl.epub
 	$(RM) pappl.xml
@@ -139,14 +160,16 @@
 	$(INSTALL) -c -m 755 makeresheader.sh $(BUILDROOT)$(bindir)/pappl-makeresheader
 	echo Installing libpappl in $(BUILDROOT)$(libdir)...
 	$(INSTALL) -d -m 755 $(BUILDROOT)$(libdir)
-	$(INSTALL) -c -m 644 libpappl.a $(BUILDROOT)$(libdir)
 	$(INSTALL) -c -m 755 $(LIBPAPPL) $(BUILDROOT)$(libdir)
 	if test "$(LIBPAPPL)" = libpappl.so.1; then \
-		$(RM) $(BUILDROOT)$(libdir)/libpappl.so; \
-		$(LN) -s libpappl.so.1 $(BUILDROOT)$(libdir)/libpappl.so; \
+	    $(RM) $(BUILDROOT)$(libdir)/libpappl.so; \
+	    $(LN) -s libpappl.so.1 $(BUILDROOT)$(libdir)/libpappl.so; \
 	elif test "$(LIBPAPPL)" = libpappl.1.dylib; then \
-		$(RM) $(BUILDROOT)$(libdir)/libpappl.dylib; \
-		$(LN) -s libpappl.1.dylib $(BUILDROOT)$(libdir)/libpappl.dylib; \
+	    $(RM) $(BUILDROOT)$(libdir)/libpappl.dylib; \
+	    $(LN) -s libpappl.1.dylib $(BUILDROOT)$(libdir)/libpappl.dylib; \
+	fi
+	if test "$(LIBPAPPL_STATIC)" = libpappl.a; then \
+	    $(INSTALL) -c -m 644 libpappl.a $(BUILDROOT)$(libdir); \
 	fi
 	echo Installing pkg-config files in $(BUILDROOT)$(libdir)/pkgconfig...
 	$(INSTALL) -d -m 755 $(BUILDROOT)$(libdir)/pkgconfig
@@ -154,17 +177,27 @@
 	echo Installing data files in $(BUILDROOT)$(datadir)/pappl...
 	$(INSTALL) -d -m 755 $(BUILDROOT)$(datadir)/pappl
 	for file in $(RESOURCES); do \
-		$(INSTALL) -c -m 644 $$file $(BUILDROOT)$(datadir)/pappl; \
+	    $(INSTALL) -c -m 644 $$file $(BUILDROOT)$(datadir)/pappl; \
 	done
 	echo Installing header files in $(BUILDROOT)$(includedir)/pappl...
 	$(INSTALL) -d -m 755 $(BUILDROOT)$(includedir)/pappl
 	for file in $(HEADERS); do \
-		$(INSTALL) -c -m 644 $$file $(BUILDROOT)$(includedir)/pappl; \
+	    $(INSTALL) -c -m 644 $$file $(BUILDROOT)$(includedir)/pappl; \
 	done
 
 
 # Test everything
 test:
+
+
+# pappl exports file
+libpappl1.def:		$(OBJS) Makefile
+	echo Generating $@...
+	echo "LIBRARY libpappl1" >libpappl1.def
+	echo "VERSION 1.2" >>libpappl1.def
+	echo "EXPORTS" >>libpappl1.def
+	(nm $(OBJS) 2>/dev/null | grep "T _" | awk '{print $$3}') | \
+		grep -v '^__' | sed -e '1,$$s/^_//' | sort >>libpappl1.def
 
 
 # pappl static library
@@ -187,9 +220,9 @@
 libpappl.1.dylib:	$(OBJS)
 	echo Linking $@...
 	$(CC) $(DSOFLAGS) -dynamiclib -o $@ \
-		-install_name $(libdir)/$@ \
-		-current_version $(PAPPL_VERSION_MAJOR).$(PAPPL_VERSION_MINOR) -compatibility_version 1.0 \
-		$(OBJS) $(LIBS)
+	    -install_name $(libdir)/$@ \
+	    -current_version $(PAPPL_VERSION_MAJOR).$(PAPPL_VERSION_MINOR) -compatibility_version 1.0 \
+	    $(OBJS) $(LIBS)
 	$(CODE_SIGN) $(CSFLAGS) -i org.msweet.pappl.`basename $@ .1.dylib` $@
 	$(RM) `basename $@ .1.dylib`.dylib
 	$(LN) $@ `basename $@ .1.dylib`.dylib
@@ -201,5 +234,37 @@
 	./makeresheader.sh $(RESOURCES) >resource-private.h
 
 
+# Update localization strings using StringUtils (<https://www.msweet.org/stringsutil>)
+.PHONY: strings
+strings:
+	echo Updating base.strings...
+	cp ipp.strings base.strings
+	stringsutil -f base.strings -n _PAPPL_LOC scan *.[cm]
+	for file in $(STRINGS); do \
+		stringsutil -f $$file -c merge base.strings; \
+	done
+stringsh:
+	echo Generating localization headers...
+	for file in $(STRINGS); do \
+		stringsutil -f $$file export strings/`basename $$file .strings`_strings.h; \
+	done
+
+
+# Analyze code with the Clang static analyzer <https://clang-analyzer.llvm.org>
+clang:
+	echo "clang $(CPPFLAGS) --analyze ..."
+	clang $(CPPFLAGS) --analyze `echo $(OBJS:.o=.c) | sed -e '1,$$s/-macos\.c/-macos.m/g'` 2>clang.log
+	rm -rf $(OBJS:.o=.plist)
+	test -s clang.log && (echo "$(GHA_ERROR)Clang detected issues."; echo ""; cat clang.log; exit 1) || exit 0
+
+
+# Analyze code using Cppcheck <http://cppcheck.sourceforge.net>
+cppcheck:
+	echo Analyzing code with Cppcheck...
+	echo 'cppcheck $(CPPFLAGS) --template=gcc --addon=cert.py --suppressions-list=cppcheck.suppressions ...'
+	cppcheck $(CPPFLAGS) --template=gcc --addon=cert.py --suppressions-list=cppcheck.suppressions `echo $(OBJS:.o=.c) | sed -e '1,$$s/-macos\.c/-macos.m/g'` 2>cppcheck.log
+	test -s cppcheck.log && (echo "$(GHA_ERROR)Cppcheck detected issues."; echo ""; cat cppcheck.log; exit 1) || exit 0
+
+
 # Dependencies
 include Dependencies

=== testsuite/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # Test suite makefile for the Printer Application Framework
 #
-# Copyright © 2020 by Michael R Sweet
+# Copyright © 2020-2022 by Michael R Sweet
 #
 # Licensed under Apache License v2.0.  See the file "LICENSE" for more
 # information.
@@ -12,10 +12,12 @@
 
 OBJS	=	\
 		pwg-driver.o \
+		testhttpmon.o \
 		testmainloop.o \
 		testpappl.o
 
 TARGETS	=	\
+		testhttpmon \
 		testmainloop \
 		testpappl
 
@@ -47,7 +49,15 @@
 	$(RM) testpappl.log
 	$(RM) -r testpappl.output
 	$(MKDIR) testpappl.output
-	./testpappl -c -l testpappl.log -L debug -o testpappl.output -t all
+	./testhttpmon 2>test.log
+	./testpappl -c -l testpappl.log -L debug -o testpappl.output -t all 2>test.log
+
+
+# HTTP monitor unit test
+testhttpmon:	testhttpmon.o ../pappl/libpappl.a
+	echo Linking $@...
+	$(CC) $(LDFLAGS) -o $@ testhttpmon.o ../pappl/libpappl.a $(LIBS)
+	$(CODE_SIGN) $(CSFLAGS) -i org.msweet.pappl.$@ $@
 
 
 # Test suite program

=== debian/changelog ===
pappl (1.2.1-1) unstable; urgency=medium

  * Update to new upstream version 1.2.1.
  * debian/tests/control: add Restrictions: allow-stderr
    (Closes: #1011990)
    (thanks to elbrus for the suggestion)

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 19 Jun 2022 11:35:04 +0200

pappl (1.2.0-1) unstable; urgency=medium

  * Update to new upstream version 1.2.0.
  * update symbols file
  * install more header files in -dev package

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 15 May 2022 23:53:17 +0200

pappl (1.1.0-3) unstable; urgency=medium

  * debian/tests: fix testsuite

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 17 Jan 2022 18:02:23 +0100

pappl (1.1.0-2) unstable; urgency=medium

  * upload to unstable

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 16 Jan 2022 08:05:23 +0000

pappl (1.1.0-1) experimental; urgency=medium

  * Update to new upstream version 1.1.0.
  * upload to experimental
  * debian/control: add myself to Uploaders:
  * do not use network in testsuite
  * due to upstream fix override for libpappl-dev is no longer needed
  * update symbols file

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 15 Jan 2022 13:05:23 +0000

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: pappl
 Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
+Uploaders: Thorsten Alteholz <debian@alteholz.de>
 Section: net
 Priority: optional
 Build-Depends:

## pappl 1.3.1

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # Top-level makefile for the Printer Application Framework
 #
-# Copyright © 2020 by Michael R Sweet
+# Copyright © 2020-2022 by Michael R Sweet
 #
 # Licensed under Apache License v2.0.  See the file "LICENSE" for more
 # information.

=== doc/Makefile ===
#
# Documentation page makefile for the Printer Application Framework
#
# Copyright © 2020 by Michael R Sweet
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include ../Makedefs


DOCFILES =	\
		pappl.html \
		pappl-512.png \
		pappl-block.png


# Make everything
all:


# Clean everything
clean:


# Clean all non-distribution files
distclean:	clean


# Update dependencies
depend:


# Install everything
install:
	echo Installing documentation in $(BUILDROOT)/$(datadir)/doc/pappl...
	$(INSTALL) -d -m 755 $(BUILDROOT)/$(datadir)/doc/pappl
	for file in $(DOCFILES); do \
		$(INSTALL) -c -m 644 $$file $(BUILDROOT)/$(datadir)/doc/pappl; \
	done


# Test everything
test:

=== pappl/Makefile ===
--- 
+++ 
@@ -87,7 +87,10 @@
 		strings/es.strings \
 		strings/fr.strings \
 		strings/it.strings \
-		strings/ja.strings
+		strings/ja.strings \
+		strings/nb-NO.strings \
+		strings/pl.strings \
+		strings/tr.strings
 
 DOCFLAGS =	\
 		--author "Michael R Sweet" \
@@ -116,7 +119,7 @@
 clean:
 	$(RM) $(OBJS)
 	$(RM) $(TARGETS)
-	$(RM) libpappl.dylib libpappl.so
+	$(RM) libpappl.dylib libpappl.so parse-lock-log
 
 
 # Clean all non-distribution files
@@ -228,6 +231,12 @@
 	$(LN) $@ `basename $@ .1.dylib`.dylib
 
 
+# parse-lock-log
+parse-lock-log:	parse-lock-log.c
+	echo Compiling and linking $@...
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<
+
+
 # Static resource header...
 resheader:	$(RESOURCES)
 	echo Generating $@...

=== testsuite/Makefile ===
--- 
+++ 
@@ -50,7 +50,7 @@
 	$(RM) -r testpappl.output
 	$(MKDIR) testpappl.output
 	./testhttpmon 2>test.log
-	./testpappl -c -l testpappl.log -L debug -o testpappl.output -t all 2>test.log
+	./testpappl -c -l testpappl.log -L debug -o testpappl.output -t api,client,pwg-raster 2>test.log
 
 
 # HTTP monitor unit test

=== debian/changelog ===
pappl (1.3.1-2) unstable; urgency=medium

  * debian/control: add dependency on libavahi-client-dev
                    (new version on pkg-config also validates whole
                     dependency tree)
    (Closes: #1023926)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 25 Feb 2023 11:44:24 +0100

pappl (1.3.1-1) unstable; urgency=medium

  * Update to new upstream version 1.3.1.
  * update symbols file

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 04 Feb 2023 12:44:24 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  libpam0g-dev,
  libpng-dev,
  libusb-1.0-0-dev,
- zlib1g-dev,
+ zlib1g-dev
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/printing-team/pappl
 Vcs-Git: https://salsa.debian.org/printing-team/pappl.git
@@ -47,6 +47,7 @@
  libpng-dev,
  libusb-1.0-0-dev,
  zlib1g-dev,
+ libavahi-client-dev,
  ${misc:Depends},
 Description: C-based framework/library for developing CUPS Printer Applications - Headers
  PAPPL is a simple C-based framework/library for developing CUPS Printer

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	# Do not build with autoreconf, see https://github.com/michaelrsweet/pappl/pull/126
	dh $@ --without autoreconf

override_dh_auto_configure:
	# Add LDFLAGS in DSOFLAGS, as that's what PAPPL uses for linking
	dh_auto_configure -- \
		--with-dsoflags="$(LDFLAGS)"

execute_before_dh_auto_clean:
	# Makedefs doesn't exist in repository/tarball; pretend it does
	touch Makedefs

execute_before_dh_auto_configure:
	# Verbose builds
	sed '/.SILENT/d' -i Makedefs.*

## pappl 1.4.9

=== pappl/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # Library makefile for the Printer Application Framework
 #
-# Copyright © 2020-2022 by Michael R Sweet
+# Copyright © 2020-2025 by Michael R Sweet
 #
 # Licensed under Apache License v2.0.  See the file "LICENSE" for more
 # information.
@@ -94,7 +94,7 @@
 
 DOCFLAGS =	\
 		--author "Michael R Sweet" \
-		--copyright "Copyright (c) 2020-2022 by Michael R Sweet" \
+		--copyright "Copyright (c) 2020-2025 by Michael R Sweet" \
 		--docversion $(PAPPL_VERSION)
 
 .SUFFIXES:	md
@@ -131,7 +131,7 @@
 	$(CC) -MM $(CFLAGS) `echo $(OBJS:.o=.c) | sed -e '1,$$s/-macos\.c/-macos.m/g'` | sed -e '1,$$s/ \/usr\/include\/[^ ]*//g' -e '1,$$s/ \/usr\/local\/include\/[^ ]*//g' >Dependencies
 
 
-# Generate documentation uaing codedoc (https://www.msweet.org/codedoc)
+# Generate documentation using codedoc (https://www.msweet.org/codedoc)
 doc:
 	echo Generating pappl.html...
 	codedoc $(DOCFLAGS) --title "PAPPL v$(PAPPL_VERSION_MAJOR).$(PAPPL_VERSION_MINOR) Programmers Manual" --coverimage ../doc/pappl-512.png --body ../doc/pappl-body.md pappl.xml $(HEADERS) $(BASEOBJS:.o=.c) >../doc/pappl.html
@@ -270,8 +270,8 @@
 # Analyze code using Cppcheck <http://cppcheck.sourceforge.net>
 cppcheck:
 	echo Analyzing code with Cppcheck...
-	echo 'cppcheck $(CPPFLAGS) --template=gcc --addon=cert.py --suppressions-list=cppcheck.suppressions ...'
-	cppcheck $(CPPFLAGS) --template=gcc --addon=cert.py --suppressions-list=cppcheck.suppressions `echo $(OBJS:.o=.c) | sed -e '1,$$s/-macos\.c/-macos.m/g'` 2>cppcheck.log
+	echo 'cppcheck $(CPPFLAGS) --template=gcc --suppressions-list=cppcheck.suppressions ...'
+	cppcheck $(CPPFLAGS) --template=gcc --suppressions-list=cppcheck.suppressions `echo $(OBJS:.o=.c) | sed -e '1,$$s/-macos\.c/-macos.m/g'` 2>cppcheck.log
 	test -s cppcheck.log && (echo "$(GHA_ERROR)Cppcheck detected issues."; echo ""; cat cppcheck.log; exit 1) || exit 0

=== testsuite/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 # Test suite makefile for the Printer Application Framework
 #
-# Copyright © 2020-2022 by Michael R Sweet
+# Copyright © 2020-2024 by Michael R Sweet
 #
 # Licensed under Apache License v2.0.  See the file "LICENSE" for more
 # information.

=== debian/changelog ===
pappl (1.4.9-0ubuntu1) plucky; urgency=medium

  * New upstream bug fix release.
  * Removed patch for "client-10x1000" test fix, included upstream.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Thu, 20 Mar 2025 18:28:59 +0100

pappl (1.4.8-0ubuntu3) plucky; urgency=medium

  * Fixed cause of crashing "client-10x1000" hight-load test in the
    autopkgtest, re-activated test.
    Upstream issue https://github.com/michaelrsweet/pappl/issues/382

 -- Till Kamppeter <till.kamppeter@gmail.com>  Fri, 14 Mar 2025 00:10:19 +0100

pappl (1.4.8-0ubuntu2) plucky; urgency=medium

  * Temporarily excluded "client-10x1000" hight-load test from the autopkgtest
    as this test often segfaults. Issue reported upstream:
    https://github.com/michaelrsweet/pappl/issues/382

 -- Till Kamppeter <till.kamppeter@gmail.com>  Thu, 27 Feb 2025 15:11:19 +0100

pappl (1.4.8-0ubuntu1) plucky; urgency=medium

  * New upstream release.
  * Updated symbols file debian/libpappl1t64.symbols.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Thu, 20 Feb 2025 13:55:19 +0100

pappl (1.3.1-2.1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:15:20 +1100

pappl (1.3.1-2.1build2) noble; urgency=medium

  * No-change rebuild against libcups2t64

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 20 Mar 2024 13:54:30 +1300

pappl (1.3.1-2.1build1) noble; urgency=medium

  * No-change rebuild against libgnutls30t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 10 Mar 2024 02:11:02 +0000

pappl (1.3.1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063207

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 19:31:57 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: pappl
-Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
 Section: net
 Priority: optional
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13),
  libavahi-client-dev,
  libcups2-dev,
@@ -20,7 +21,10 @@
 Homepage: https://www.msweet.org/pappl/
 Rules-Requires-Root: no
 
-Package: libpappl1
+Package: libpappl1t64
+Provides: ${t64:Provides}
+Replaces: libpappl1
+Breaks: libpappl1 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -43,7 +47,7 @@
  libgnutls28-dev,
  libjpeg-dev,
  libpam0g-dev,
- libpappl1 (= ${binary:Version}),
+ libpappl1t64 (= ${binary:Version}),
  libpng-dev,
  libusb-1.0-0-dev,
  zlib1g-dev,

=== debian/tests/control ===
--- 
+++ 
@@ -4,3 +4,4 @@
  build-essential,
  libpappl-dev,
  pkg-config,
+Restrictions: allow-stderr
